/**
 * Generated by Apache Royale Compiler from mx/events/DragEvent.as
 * mx.events.DragEvent
 *
 * @fileoverview
 *
 * @suppress {checkTypes|accessControls}
 */

goog.provide('mx.events.DragEvent');

goog.require('mx.core.DragSource');
goog.require('mx.core.IUIComponent');
goog.require('mx.events.MouseEvent');
goog.require('XML');



/**
 *  Constructor.
 *  Normally called by the Flex control and not used in application code.
 *
 *  @asparam type The event type; indicates the action that caused the event.
 *
 *  @asparam bubbles Specifies whether the event can bubble up the display list hierarchy.
 *
 *  @asparam cancelable Specifies whether the behavior associated with the event can be prevented.
 *
 *  @asparam dragInitiator IUIComponent that specifies the component initiating
 *  the drag.
 *
 *  @asparam dragSource A DragSource object containing the data being dragged.
 *
 *  @asparam action The specified drop action, such as <code>DragManager.MOVE</code>.
 *
 *  @asparam ctrlKey Indicates whether the <code>Ctrl</code> key was pressed.
 *
 *  @asparam altKey Indicates whether the <code>Alt</code> key was pressed.
 *
 *  @asparam shiftKey Indicates whether the <code>Shift</code> key was pressed.
 *  
 *  @langversion 3.0
 *  @playerversion Flash 9
 *  @playerversion AIR 1.1
 *  @productversion Flex 3
 * @constructor
 * @extends {mx.events.MouseEvent}
 * @param {string} type
 * @param {boolean=} bubbles
 * @param {boolean=} cancelable
 * @param {mx.core.IUIComponent=} dragInitiator
 * @param {mx.core.DragSource=} dragSource
 * @param {string=} action
 * @param {boolean=} ctrlKey
 * @param {boolean=} altKey
 * @param {boolean=} shiftKey
 */
mx.events.DragEvent = function(type, bubbles, cancelable, dragInitiator, dragSource, action, ctrlKey, altKey, shiftKey) {
  bubbles = typeof bubbles !== 'undefined' ? bubbles : false;
  cancelable = typeof cancelable !== 'undefined' ? cancelable : true;
  dragInitiator = typeof dragInitiator !== 'undefined' ? dragInitiator : null;
  dragSource = typeof dragSource !== 'undefined' ? dragSource : null;
  action = typeof action !== 'undefined' ? action : null;
  ctrlKey = typeof ctrlKey !== 'undefined' ? ctrlKey : false;
  altKey = typeof altKey !== 'undefined' ? altKey : false;
  shiftKey = typeof shiftKey !== 'undefined' ? shiftKey : false;
  mx.events.DragEvent.base(this, 'constructor', type, bubbles, cancelable);
  this.dragInitiator = dragInitiator;
  this.dragSource = dragSource;
  this.action = action;
};
goog.inherits(mx.events.DragEvent, mx.events.MouseEvent);


/**
 * @nocollapse
 * @const
 * @type {string}
 */
mx.events.DragEvent.DRAG_COMPLETE = "dragComplete";


/**
 * @nocollapse
 * @const
 * @type {string}
 */
mx.events.DragEvent.DRAG_DROP = "dragDrop";


/**
 * @nocollapse
 * @const
 * @type {string}
 */
mx.events.DragEvent.DRAG_ENTER = "dragEnter";


/**
 * @nocollapse
 * @const
 * @type {string}
 */
mx.events.DragEvent.DRAG_EXIT = "dragExit";


/**
 * @nocollapse
 * @const
 * @type {string}
 */
mx.events.DragEvent.DRAG_OVER = "dragOver";


/**
 * @nocollapse
 * @const
 * @type {string}
 */
mx.events.DragEvent.DRAG_START = "dragStart";


/**
 * @type {string}
 */
mx.events.DragEvent.prototype.action;


/**
 * @type {mx.core.IUIComponent}
 */
mx.events.DragEvent.prototype.dragInitiator;


/**
 * @type {mx.core.DragSource}
 */
mx.events.DragEvent.prototype.dragSource;


/**
 * Metadata
 *
 * @type {Object.<string, Array.<Object>>}
 */
mx.events.DragEvent.prototype.ROYALE_CLASS_INFO = { names: [{ name: 'DragEvent', qName: 'mx.events.DragEvent', kind: 'class' }] };



/**
 * Reflection
 *
 * @return {Object.<string, Function>}
 */
mx.events.DragEvent.prototype.ROYALE_REFLECTION_INFO = function () {
  return {
    variables: function () {
      return {
        'action': { type: 'String', get_set: function (/** mx.events.DragEvent */ inst, /** * */ v) {return v !== undefined ? inst.action = v : inst.action;}},
        'dragInitiator': { type: 'mx.core.IUIComponent', get_set: function (/** mx.events.DragEvent */ inst, /** * */ v) {return v !== undefined ? inst.dragInitiator = v : inst.dragInitiator;}},
        'dragSource': { type: 'mx.core.DragSource', get_set: function (/** mx.events.DragEvent */ inst, /** * */ v) {return v !== undefined ? inst.dragSource = v : inst.dragSource;}}
      };
    },
    methods: function () {
      return {
        'DragEvent': { type: '', declaredBy: 'mx.events.DragEvent', parameters: function () { return [ 'String', false ,'Boolean', true ,'Boolean', true ,'mx.core.IUIComponent', true ,'mx.core.DragSource', true ,'String', true ,'Boolean', true ,'Boolean', true ,'Boolean', true ]; }}
      };
    }
  };
};
/**
 * @const
 * @type {number}
 */
mx.events.DragEvent.prototype.ROYALE_COMPILE_FLAGS = 10;