/**
 * Generated by Apache Royale Compiler from mx/managers/DragManagerImpl.as
 * mx.managers.DragManagerImpl
 *
 * @fileoverview
 *
 * @suppress {checkTypes|accessControls}
 */

goog.provide('mx.managers.DragManagerImpl');

goog.require('mx.core.DragSource');
goog.require('mx.core.IFlexDisplayObject');
goog.require('mx.core.IUIComponent');
goog.require('mx.managers.IDragManager');
goog.require('mx.managers.ISystemManager');
goog.require('mx.managers.beads.DragManagerImplDropBead');
goog.require('org.apache.royale.core.IStrand');
goog.require('org.apache.royale.core.IUIBase');
goog.require('org.apache.royale.core.Lookalike');
goog.require('org.apache.royale.core.UIBase');
goog.require('org.apache.royale.events.DragEvent');
goog.require('org.apache.royale.events.Event');
goog.require('org.apache.royale.events.EventDispatcher');
goog.require('org.apache.royale.events.IEventDispatcher');
goog.require('org.apache.royale.events.MouseEvent');
goog.require('org.apache.royale.html.beads.controllers.DragMouseController');
goog.require('org.apache.royale.core.IBead');
goog.require('org.apache.royale.utils.Language');
goog.require('XML');



/**
 *  @asprivate
 * @constructor
 * @extends {org.apache.royale.events.EventDispatcher}
 * @implements {mx.managers.IDragManager}
 * @implements {org.apache.royale.core.IBead}
 */
mx.managers.DragManagerImpl = function() {
  mx.managers.DragManagerImpl.base(this, 'constructor');
  if (mx.managers.DragManagerImpl.instance)
    throw new Error("Instance already exists.");
  if (mx.managers.DragManagerImpl.mixins) {
    var /** @type {number} */ n = (mx.managers.DragManagerImpl.mixins.length) >> 0;
    for (var /** @type {number} */ i = 0; i < n; i++) {
      new mx.managers.DragManagerImpl.mixins[i](this);
    }
  }
  if (this.hasEventListener("initialize"))
    this.dispatchEvent(new org.apache.royale.events.Event("initialize"));
};
goog.inherits(mx.managers.DragManagerImpl, org.apache.royale.events.EventDispatcher);


/**
 * @private
 * @type {mx.managers.ISystemManager}
 */
mx.managers.DragManagerImpl.sm;


/**
 * @private
 * @type {mx.managers.IDragManager}
 */
mx.managers.DragManagerImpl.instance;


/**
 * @nocollapse
 * @type {Array}
 */
mx.managers.DragManagerImpl.mixins;


/**
 *  @asprivate
 * @nocollapse
 * @return {mx.managers.IDragManager}
 */
mx.managers.DragManagerImpl.getInstance = function() {
  if (!mx.managers.DragManagerImpl.instance)
    mx.managers.DragManagerImpl.instance = new mx.managers.DragManagerImpl();
  return mx.managers.DragManagerImpl.instance;
};


/**
 * @private
 * @type {org.apache.royale.events.IEventDispatcher}
 */
mx.managers.DragManagerImpl.prototype.mx_managers_DragManagerImpl_sandboxRoot;


/**
 * @private
 * @type {mx.core.IUIComponent}
 */
mx.managers.DragManagerImpl.prototype.mx_managers_DragManagerImpl_dragInitiator;


/**
 * @type {boolean}
 */
mx.managers.DragManagerImpl.prototype.bDoingDrag = false;


/**
 * @private
 * @type {boolean}
 */
mx.managers.DragManagerImpl.prototype.mx_managers_DragManagerImpl_mouseIsDown = false;


/**
 *  Initiates a drag and drop operation.
 *
 *  @asparam dragInitiator IUIComponent that specifies the component initiating
 *  the drag.
 *
 *  @asparam dragSource DragSource object that contains the data
 *  being dragged.
 *
 *  @asparam mouseEvent The MouseEvent that contains the mouse information
 *  for the start of the drag.
 *
 *  @asparam dragImage The image to drag. This argument is optional.
 *  If omitted, a standard drag rectangle is used during the drag and
 *  drop operation. If you specify an image, you must explicitly set a 
 *  height and width of the image or else it will not appear.
 *
 *  @asparam xOffset Number that specifies the x offset, in pixels, for the
 *  <code>dragImage</code>. This argument is optional. If omitted, the drag proxy
 *  is shown at the upper-left corner of the drag initiator. The offset is expressed
 *  in pixels from the left edge of the drag proxy to the left edge of the drag
 *  initiator, and is usually a negative number.
 *
 *  @asparam yOffset Number that specifies the y offset, in pixels, for the
 *  <code>dragImage</code>. This argument is optional. If omitted, the drag proxy
 *  is shown at the upper-left corner of the drag initiator. The offset is expressed
 *  in pixels from the top edge of the drag proxy to the top edge of the drag
 *  initiator, and is usually a negative number.
 *
 *  @asparam imageAlpha Number that specifies the alpha value used for the
 *  drag image. This argument is optional. If omitted, the default alpha
 *  value is 0.5. A value of 0.0 indicates that the image is transparent;
 *  a value of 1.0 indicates it is fully opaque. 
 *  
 *  @langversion 3.0
 *  @playerversion Flash 9
 *  @playerversion AIR 1.1
 *  @productversion Flex 3
 * @param {mx.core.IUIComponent} dragInitiator
 * @param {mx.core.DragSource} dragSource
 * @param {org.apache.royale.events.MouseEvent} mouseEvent
 * @param {mx.core.IFlexDisplayObject=} dragImage
 * @param {number=} xOffset
 * @param {number=} yOffset
 * @param {number=} imageAlpha
 * @param {boolean=} allowMove
 */
mx.managers.DragManagerImpl.prototype.doDrag = function(dragInitiator, dragSource, mouseEvent, dragImage, xOffset, yOffset, imageAlpha, allowMove) {
  dragImage = typeof dragImage !== 'undefined' ? dragImage : null;
  xOffset = typeof xOffset !== 'undefined' ? xOffset : 0;
  yOffset = typeof yOffset !== 'undefined' ? yOffset : 0;
  imageAlpha = typeof imageAlpha !== 'undefined' ? imageAlpha : 0.5;
  allowMove = typeof allowMove !== 'undefined' ? allowMove : true;
  if (this.hasEventListener("doDrag"))
    this.dispatchEvent(new org.apache.royale.events.Event("doDrag"));
  var /** @type {org.apache.royale.html.beads.controllers.DragMouseController} */ dragController = org.apache.royale.utils.Language.as(org.apache.royale.utils.Language.as(dragInitiator, org.apache.royale.core.IStrand).getBeadByType(org.apache.royale.html.beads.controllers.DragMouseController), org.apache.royale.html.beads.controllers.DragMouseController);
  if (!dragController) {
    dragController = new org.apache.royale.html.beads.controllers.DragMouseController();
    org.apache.royale.utils.Language.as(dragInitiator, org.apache.royale.core.IStrand).addBead(dragController);
    org.apache.royale.utils.Language.as(dragInitiator, org.apache.royale.events.IEventDispatcher).dispatchEvent(mouseEvent);
  }
  this.mx_managers_DragManagerImpl_dragInitiator = dragInitiator;
  dragController.addEventListener("dragMove", org.apache.royale.utils.Language.closure(this.mx_managers_DragManagerImpl_dragMoveHandler, this, 'mx_managers_DragManagerImpl_dragMoveHandler'));
  dragController.addEventListener("dragStart", org.apache.royale.utils.Language.closure(this.mx_managers_DragManagerImpl_dragStartHandler, this, 'mx_managers_DragManagerImpl_dragStartHandler'));
  this.mx_managers_DragManagerImpl__dragSource = dragSource;
  this.mx_managers_DragManagerImpl__lookAlike = this.createDragImage(dragInitiator);
};


/**
 * @private
 * @type {org.apache.royale.core.UIBase}
 */
mx.managers.DragManagerImpl.prototype.mx_managers_DragManagerImpl__lookAlike;


/**
 * @protected
 * @param {org.apache.royale.core.IUIBase} dragInitiator
 * @return {org.apache.royale.core.UIBase}
 */
mx.managers.DragManagerImpl.prototype.createDragImage = function(dragInitiator) {
  var /** @type {org.apache.royale.core.UIBase} */ dragImage = new org.apache.royale.core.Lookalike(dragInitiator);
  dragImage.className = "DragImage";
  dragImage.width = dragInitiator.width;
  dragImage.height = dragInitiator.height;
  dragImage.element.style.position = 'absolute';
  dragImage.element.style.cursor = 'pointer';
  return dragImage;
};


/**
 * @private
 * @type {mx.core.DragSource}
 */
mx.managers.DragManagerImpl.prototype.mx_managers_DragManagerImpl__dragSource;


/**
 * @private
 * @param {org.apache.royale.events.DragEvent} event
 */
mx.managers.DragManagerImpl.prototype.mx_managers_DragManagerImpl_dragStartHandler = function(event) {
  org.apache.royale.events.DragEvent.dragSource = this.mx_managers_DragManagerImpl__dragSource;
  org.apache.royale.html.beads.controllers.DragMouseController.dragImage = this.mx_managers_DragManagerImpl__lookAlike;
};


/**
 * @private
 * @param {org.apache.royale.events.DragEvent} event
 */
mx.managers.DragManagerImpl.prototype.mx_managers_DragManagerImpl_dragMoveHandler = function(event) {
  var /** @type {org.apache.royale.events.IEventDispatcher} */ relatedObject = org.apache.royale.utils.Language.as(event.relatedObject, org.apache.royale.events.IEventDispatcher);
  if (!relatedObject) {
    return;
  }
  if (relatedObject.hasEventListener(org.apache.royale.events.DragEvent.DRAG_ENTER) || relatedObject.hasEventListener(org.apache.royale.events.DragEvent.DRAG_EXIT) || relatedObject.hasEventListener(org.apache.royale.events.DragEvent.DRAG_OVER) || relatedObject.hasEventListener(org.apache.royale.events.DragEvent.DRAG_DROP)) {
    var /** @type {org.apache.royale.core.IStrand} */ relatedStrand = org.apache.royale.utils.Language.as(relatedObject, org.apache.royale.core.IStrand);
    var /** @type {mx.managers.beads.DragManagerImplDropBead} */ dmDropBead = org.apache.royale.utils.Language.as(relatedStrand.getBeadByType(mx.managers.beads.DragManagerImplDropBead), mx.managers.beads.DragManagerImplDropBead);
    if (!dmDropBead) {
      dmDropBead = new mx.managers.beads.DragManagerImplDropBead(this.mx_managers_DragManagerImpl_dragInitiator);
      relatedStrand.addBead(dmDropBead);
    }
  }
};


/**
 *  Call this method from your <code>dragEnter</code> event handler if you accept
 *  the drag/drop data.
 *  For example: 
 *
 *  <pre>DragManager.acceptDragDrop(event.target);</pre>
 *
 *	@asparam target The drop target accepting the drag.
 *  
 *  @langversion 3.0
 *  @playerversion Flash 9
 *  @playerversion AIR 1.1
 *  @productversion Flex 3
 * @param {mx.core.IUIComponent} target
 */
mx.managers.DragManagerImpl.prototype.acceptDragDrop = function(target) {
};


/**
 *  Sets the feedback indicator for the drag and drop operation.
 *  Possible values are <code>DragManager.COPY</code>, <code>DragManager.MOVE</code>,
 *  <code>DragManager.LINK</code>, or <code>DragManager.NONE</code>.
 *
 *  @asparam feedback The type of feedback indicator to display.
 *  
 *  @langversion 3.0
 *  @playerversion Flash 9
 *  @playerversion AIR 1.1
 *  @productversion Flex 3
 * @param {string} feedback
 */
mx.managers.DragManagerImpl.prototype.showFeedback = function(feedback) {
};


/**
 *  Returns the current drag and drop feedback.
 *
 *  @asreturn  Possible return values are <code>DragManager.COPY</code>, 
 *  <code>DragManager.MOVE</code>,
 *  <code>DragManager.LINK</code>, or <code>DragManager.NONE</code>.
 *  
 *  @langversion 3.0
 *  @playerversion Flash 9
 *  @playerversion AIR 1.1
 *  @productversion Flex 3
 * @return {string}
 */
mx.managers.DragManagerImpl.prototype.getFeedback = function() {
  return null;
};


/**
 *  @asprivate
 */
mx.managers.DragManagerImpl.prototype.endDrag = function() {
};


/**
 * @private
 * @type {org.apache.royale.core.IStrand}
 */
mx.managers.DragManagerImpl.prototype.mx_managers_DragManagerImpl__strand;


/**
 * @nocollapse
 * @export
 * @type {boolean}
 */
mx.managers.DragManagerImpl.prototype.isDragging;


mx.managers.DragManagerImpl.prototype.get__isDragging = function() {
  return this.bDoingDrag;
};


/**
 * @nocollapse
 * @export
 * @type {org.apache.royale.core.IStrand}
 */
mx.managers.DragManagerImpl.prototype.strand;


mx.managers.DragManagerImpl.prototype.set__strand = function(value) {
  this.mx_managers_DragManagerImpl__strand = value;
};


Object.defineProperties(mx.managers.DragManagerImpl.prototype, /** @lends {mx.managers.DragManagerImpl.prototype} */ {
/**
 * @type {boolean}
 */
isDragging: {
get: mx.managers.DragManagerImpl.prototype.get__isDragging},
/**
 * @type {org.apache.royale.core.IStrand}
 */
strand: {
set: mx.managers.DragManagerImpl.prototype.set__strand}}
);


/**
 * Metadata
 *
 * @type {Object.<string, Array.<Object>>}
 */
mx.managers.DragManagerImpl.prototype.ROYALE_CLASS_INFO = { names: [{ name: 'DragManagerImpl', qName: 'mx.managers.DragManagerImpl', kind: 'class' }], interfaces: [mx.managers.IDragManager, org.apache.royale.core.IBead] };



/**
 * Reflection
 *
 * @return {Object.<string, Function>}
 */
mx.managers.DragManagerImpl.prototype.ROYALE_REFLECTION_INFO = function () {
  return {
    variables: function () {
      return {
        '|mixins': { type: 'Array', get_set: function (/** * */ v) {return v !== undefined ? mx.managers.DragManagerImpl.mixins = v : mx.managers.DragManagerImpl.mixins;}},
        'bDoingDrag': { type: 'Boolean', get_set: function (/** mx.managers.DragManagerImpl */ inst, /** * */ v) {return v !== undefined ? inst.bDoingDrag = v : inst.bDoingDrag;}}
      };
    },
    accessors: function () {
      return {
        'isDragging': { type: 'Boolean', access: 'readonly', declaredBy: 'mx.managers.DragManagerImpl'},
        'strand': { type: 'org.apache.royale.core.IStrand', access: 'writeonly', declaredBy: 'mx.managers.DragManagerImpl'}
      };
    },
    methods: function () {
      return {
        '|getInstance': { type: 'mx.managers.IDragManager', declaredBy: 'mx.managers.DragManagerImpl'},
        'DragManagerImpl': { type: '', declaredBy: 'mx.managers.DragManagerImpl'},
        'doDrag': { type: 'void', declaredBy: 'mx.managers.DragManagerImpl', parameters: function () { return [ 'mx.core.IUIComponent', false ,'mx.core.DragSource', false ,'org.apache.royale.events.MouseEvent', false ,'mx.core.IFlexDisplayObject', true ,'Number', true ,'Number', true ,'Number', true ,'Boolean', true ]; }},
        'acceptDragDrop': { type: 'void', declaredBy: 'mx.managers.DragManagerImpl', parameters: function () { return [ 'mx.core.IUIComponent', false ]; }},
        'showFeedback': { type: 'void', declaredBy: 'mx.managers.DragManagerImpl', parameters: function () { return [ 'String', false ]; }},
        'getFeedback': { type: 'String', declaredBy: 'mx.managers.DragManagerImpl'},
        'endDrag': { type: 'void', declaredBy: 'mx.managers.DragManagerImpl'}
      };
    }
  };
};
/**
 * @const
 * @type {number}
 */
mx.managers.DragManagerImpl.prototype.ROYALE_COMPILE_FLAGS = 10;